org.apache.commons.collections4.set

## Class PredicatedSortedSet<E>

- java.lang.Object
- - org.apache.commons.collections4.collection.AbstractCollectionDecorator<E>
  - - org.apache.commons.collections4.collection.PredicatedCollection<E>
    - - org.apache.commons.collections4.set.PredicatedSet<E>
      - - org.apache.commons.collections4.set.PredicatedSortedSet<E>

- Type Parameters:
    `E` - the type of the elements in this set
  All Implemented Interfaces:
    Serializable, Iterable<E>, Collection<E>, Set<E>, SortedSet<E>
  Direct Known Subclasses:
    PredicatedNavigableSet

      public class PredicatedSortedSet<E>
      extends PredicatedSet<E>
      implements SortedSet<E>

  Decorates another `SortedSet` to validate that all additions match a specified predicate.

  This set exists to provide validation for the decorated set. It is normally created to decorate an empty set. If an object cannot be added to the set, an IllegalArgumentException is thrown.

  One usage would be to ensure that no null entries are added to the set.

       SortedSet set =
         PredicatedSortedSet.predicatedSortedSet(new TreeSet(),
                                                 NotNullPredicate.notNullPredicate());

  This class is Serializable from Commons Collections 3.1.

  Since:
    3.0
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.commons.collections4.collection.PredicatedCollection

      `PredicatedCollection.Builder<E>`

  - ### Field Summary

    - ### Fields inherited from class org.apache.commons.collections4.collection.PredicatedCollection

      `predicate`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `PredicatedSortedSet(SortedSet<E> set, Predicate<? super E> predicate)` Constructor that wraps (not copies).

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Comparator<? super E>` | `comparator()`
    `protected SortedSet<E>` | `decorated()` Gets the sorted set being decorated.
    `E` | `first()`
    `SortedSet<E>` | `headSet(E toElement)`
    `E` | `last()`
    `static <E> PredicatedSortedSet<E>` | `predicatedSortedSet(SortedSet<E> set, Predicate<? super E> predicate)` Factory method to create a predicated (validating) sorted set.
    `SortedSet<E>` | `subSet(E fromElement, E toElement)`
    `SortedSet<E>` | `tailSet(E fromElement)`

    - ### Methods inherited from class org.apache.commons.collections4.set.PredicatedSet

      `equals, hashCode, predicatedSet`

    - ### Methods inherited from class org.apache.commons.collections4.collection.PredicatedCollection

      `add, addAll, builder, notNullBuilder, predicatedCollection, validate`

    - ### Methods inherited from class org.apache.commons.collections4.collection.AbstractCollectionDecorator

      `clear, contains, containsAll, isEmpty, iterator, remove, removeAll, removeIf, retainAll, setCollection, size, toArray, toArray, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface java.util.SortedSet

      `spliterator`

    - ### Methods inherited from interface java.util.Set

      `add, addAll, clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray`

    - ### Methods inherited from interface java.util.Collection

      `parallelStream, removeIf, stream`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

- - ### Constructor Detail

    - #### PredicatedSortedSet

          protected PredicatedSortedSet(SortedSet<E> set,
                                        Predicate<? super E> predicate)

      Constructor that wraps (not copies).

      If there are any elements already in the set being decorated, they are validated.

      Parameters:
        `set` - the set to decorate, must not be null
        `predicate` - the predicate to use for validation, must not be null
      Throws:
        `NullPointerException` - if set or predicate is null
        `IllegalArgumentException` - if the set contains invalid elements

  - ### Method Detail

    - #### predicatedSortedSet

          public static <E> PredicatedSortedSet<E> predicatedSortedSet(SortedSet<E> set,
                                                                       Predicate<? super E> predicate)

      Factory method to create a predicated (validating) sorted set.

      If there are any elements already in the set being decorated, they are validated.

      Type Parameters:
        `E` - the element type
      Parameters:
        `set` - the set to decorate, must not be null
        `predicate` - the predicate to use for validation, must not be null
      Returns:
        a new predicated sorted set.
      Throws:
        `NullPointerException` - if set or predicate is null
        `IllegalArgumentException` - if the set contains invalid elements
      Since:
        4.0

    - #### decorated

          protected SortedSet<E> decorated()

      Gets the sorted set being decorated.
      Overrides:
        `decorated` in class `PredicatedSet<E>`
      Returns:
        the decorated sorted set

    - #### comparator

          public Comparator<? super E> comparator()

      Specified by:
        `comparator` in interface `SortedSet<E>`

    - #### first

          public E first()

      Specified by:
        `first` in interface `SortedSet<E>`

    - #### last

          public E last()

      Specified by:
        `last` in interface `SortedSet<E>`

    - #### subSet

          public SortedSet<E> subSet(E fromElement,
                                     E toElement)

      Specified by:
        `subSet` in interface `SortedSet<E>`

    - #### headSet

          public SortedSet<E> headSet(E toElement)

      Specified by:
        `headSet` in interface `SortedSet<E>`

    - #### tailSet

          public SortedSet<E> tailSet(E fromElement)

      Specified by:
        `tailSet` in interface `SortedSet<E>`

Copyright © 2001–2019 The Apache Software Foundation. All rights reserved.